"""
Module realize classproperty getter
"""

from typing import Any, Callable, Type


class classproperty:  # pylint: disable-msg=C0103
    """
    Descriptor property getter only
    Attributes:
        func (Callable): classmethod
    """

    def __init__(self, func: Callable):
        self.func = func

    def __get__(self, obj: Any, klass: Type):
        """
        Getter
        Args:
            obj: class instance
            klass: class

        Returns:
            result of func
        """
        return self.func(klass)
