"""
Custom types
"""

# todo remove pylint: disable-msg=fixme
from pydantic.types import StrictFloat, StrictInt


class Int16(StrictInt):
    """
    Int of range -32768 - 32767
    """

    ge = -32768
    le = 32767


class Int32(StrictInt):
    """
    Int of range -2147483648 - 2147483647
    """

    ge = -2147483648
    le = 2147483647


class Float16(StrictFloat):
    """
    Float of range -32768 - 32767
    """

    ge = -2147483648
    le = 2147483647


class Float32(StrictFloat):
    """
    Float of range -2147483648 - 2147483647
    """

    ge = -2147483648
    le = 2147483647


# todo remove
class LimitedInt(StrictInt):
    """
    Int of range -2147483648 - 2147483647
    """

    ge = -2147483648
    le = 2147483647


# todo remove
class LimitedNonNegativeInt(StrictInt):
    """
    Int of range 0 - 2147483647
    """

    ge = 0
    le = 2147483647


# todo remove
class LimitedPositiveInt(LimitedNonNegativeInt):
    """
    Int of range 1 - 2147483647
    """

    ge = 1


# todo remove
class Int16Positive(Int16):
    """
    Int of range 1 - 32767
    """

    ge = 1


# todo remove
class LimitedFloat(StrictFloat):
    """
    Float of range -2147483648 - 2147483647
    """

    ge = -2147483648
    le = 2147483647


# todo remove
class LimitedNonNegativeFloat(StrictFloat):
    """
    Float of range 0 - 2147483647
    """

    ge = 0
    le = 2147483647
